class CRF(Module):
  __parameters__ = ["transitions", ]
  __buffers__ = []
  transitions : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  start_tag : int
  stop_tag : int
  gpu : bool
  tagset_size : int
  def forward(self: __torch__.orkg_cs_ner.ncrfpp.model.crf.CRF,
    feats: Tensor,
    mask: Tensor,
    nbest: int) -> Tuple[Tensor, Tensor]:
    _0 = __torch__.torch.nn.functional.softmax
    batch_size = torch.size(feats, 0)
    seq_len = torch.size(feats, 1)
    tag_size = torch.size(feats, 2)
    tagset_size = self.tagset_size
    _1 = torch.eq(tag_size, torch.add(tagset_size, 2))
    if _1:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _2 = torch.view(torch.sum(torch.to(mask, 4), [1]), [batch_size, 1])
    length_mask = torch.to(_2, 4)
    mask0 = torch.contiguous(torch.transpose(mask, 1, 0))
    ins_num = torch.mul(seq_len, batch_size)
    _3 = torch.contiguous(torch.transpose(feats, 1, 0))
    _4 = torch.view(_3, [ins_num, 1, tag_size])
    feats0 = torch.expand(_4, [ins_num, tag_size, tag_size])
    transitions = self.transitions
    _5 = torch.view(transitions, [1, tag_size, tag_size])
    _6 = torch.expand(_5, [ins_num, tag_size, tag_size])
    scores = torch.add(feats0, _6)
    _7 = [seq_len, batch_size, tag_size, tag_size]
    scores0 = torch.view(scores, _7)
    back_points = annotate(List[Tensor], [])
    partition_history = annotate(List[Tensor], [])
    _8 = torch.add(torch.neg(torch.to(mask0, 4)), 1)
    mask1 = torch.to(_8, 11)
    inivalues = torch.select(scores0, 0, 0)
    start_tag = self.start_tag
    _9 = torch.select(torch.slice(inivalues), 1, start_tag)
    partition = torch.clone(torch.slice(_9, 1))
    _10 = torch.view(partition, [batch_size, tag_size, 1])
    _11 = torch.expand(_10, [batch_size, tag_size, nbest])
    _12 = torch.append(partition_history, _11)
    _13 = [9223372036854775807, torch.len(scores0)]
    _14 = ops.prim.min(_13)
    partition0 = partition
    _15 = 0
    _16 = torch.gt(_14, 0)
    while _16:
      cur_values = torch.select(scores0, 0, _15)
      if torch.eq(_15, 0):
        _17 = partition0
      else:
        if torch.eq(_15, 1):
          _18 = [batch_size, tag_size, tag_size]
          _19 = torch.view(cur_values, _18)
          _20 = torch.view(torch.contiguous(partition0), [batch_size, tag_size, 1])
          _21 = [batch_size, tag_size, tag_size]
          cur_values1 = torch.add(_19, torch.expand(_20, _21))
          cur_values0 = cur_values1
        else:
          _22 = [batch_size, tag_size, 1, tag_size]
          _23 = torch.view(cur_values, _22)
          _24 = [batch_size, tag_size, nbest, tag_size]
          _25 = torch.expand(_23, _24)
          _26 = torch.contiguous(partition0)
          _27 = [batch_size, tag_size, nbest, 1]
          _28 = torch.view(_26, _27)
          _29 = [batch_size, tag_size, nbest, tag_size]
          cur_values2 = torch.add(_25, torch.expand(_28, _29))
          _30 = [batch_size, torch.mul(tag_size, nbest), tag_size]
          cur_values0 = torch.view(cur_values2, _30)
        partition1, cur_bp = torch.topk(cur_values0, nbest, 1)
        if torch.eq(_15, 1):
          cur_bp0 = torch.mul(cur_bp, nbest)
        else:
          cur_bp0 = cur_bp
        partition2 = torch.transpose(partition1, 2, 1)
        cur_bp1 = torch.transpose(cur_bp0, 2, 1)
        _31 = torch.append(partition_history, partition2)
        _32 = torch.view(torch.select(mask1, 0, _15), [batch_size, 1, 1])
        _33 = torch.expand(_32, [batch_size, tag_size, nbest])
        _34 = torch.masked_fill_(cur_bp1, _33, 0)
        _35 = torch.append(back_points, cur_bp1)
        _17 = partition2
      _36 = torch.add(_15, 1)
      _37 = torch.__and__(torch.lt(_36, _14), True)
      _16, partition0, _15 = _37, _17, _36
    _38 = torch.cat(partition_history)
    _39 = [seq_len, batch_size, tag_size, nbest]
    _40 = torch.transpose(torch.view(_38, _39), 1, 0)
    partition_history0 = torch.contiguous(_40)
    _41 = torch.view(length_mask, [batch_size, 1, 1, 1])
    _42 = torch.expand(_41, [batch_size, 1, tag_size, nbest])
    last_position = torch.sub(_42, 1)
    _43 = torch.gather(partition_history0, 1, last_position)
    last_partition = torch.view(_43, [batch_size, tag_size, nbest, 1])
    _44 = [batch_size, tag_size, nbest, tag_size]
    _45 = torch.expand(last_partition, _44)
    transitions0 = self.transitions
    _46 = torch.view(transitions0, [1, tag_size, 1, tag_size])
    _47 = [batch_size, tag_size, nbest, tag_size]
    last_values = torch.add(_45, torch.expand(_46, _47))
    _48 = [batch_size, torch.mul(tag_size, nbest), tag_size]
    last_values0 = torch.view(last_values, _48)
    end_partition, end_bp = torch.topk(last_values0, nbest, 1)
    end_bp0 = torch.transpose(end_bp, 2, 1)
    _49 = torch.zeros([batch_size, tag_size, nbest])
    pad_zero = torch.to(_49, 4)
    gpu = self.gpu
    if gpu:
      pad_zero0 = torch.cuda(pad_zero)
    else:
      pad_zero0 = pad_zero
    _50 = torch.append(back_points, pad_zero0)
    _51 = torch.cat(back_points)
    _52 = [seq_len, batch_size, tag_size, nbest]
    back_points0 = torch.view(_51, _52)
    stop_tag = self.stop_tag
    _53 = torch.select(torch.slice(end_bp0), 1, stop_tag)
    pointer = torch.slice(_53, 1)
    _54 = torch.view(torch.contiguous(pointer), [batch_size, 1, 1, nbest])
    insert_last = torch.expand(_54, [batch_size, 1, tag_size, nbest])
    back_points1 = torch.contiguous(torch.transpose(back_points0, 1, 0))
    _55 = torch.scatter_(back_points1, 1, last_position, insert_last)
    back_points2 = torch.contiguous(torch.transpose(back_points1, 1, 0))
    decode_idx = torch.empty([seq_len, batch_size, nbest], dtype=4)
    gpu0 = self.gpu
    if gpu0:
      decode_idx0 = torch.cuda(decode_idx)
    else:
      decode_idx0 = decode_idx
    _56 = torch.div(ops.prim.data(pointer), nbest)
    _57 = torch.copy_(torch.select(decode_idx0, 0, -1), _56)
    _58 = torch.sub(torch.len(back_points2), 2)
    pointer0 = pointer
    for _59 in range(torch.__range_length(_58, -1, -1)):
      idx = torch.__derive_index(_59, _58, -1)
      _60 = torch.select(back_points2, 0, idx)
      _61 = [batch_size, torch.mul(tag_size, nbest)]
      _62 = torch.view(_60, _61)
      _63 = torch.view(torch.contiguous(pointer0), [batch_size, nbest])
      new_pointer = torch.gather(_62, 1, _63)
      _64 = torch.div(ops.prim.data(new_pointer), nbest)
      _65 = torch.copy_(torch.select(decode_idx0, 0, idx), _64)
      _66 = torch.view(torch.contiguous(pointer0), [batch_size, nbest])
      _67 = torch.view(torch.select(mask1, 0, idx), [batch_size, 1])
      _68 = torch.expand(_67, [batch_size, nbest])
      pointer1 = torch.add(new_pointer, torch.mul(_66, torch.to(_68, 4)))
      pointer0 = pointer1
    decode_idx1 = torch.transpose(decode_idx0, 1, 0)
    stop_tag0 = self.stop_tag
    _69 = torch.slice(torch.slice(end_partition), 1)
    scores1 = torch.select(_69, 2, stop_tag0)
    max_scores, _70 = torch.max(scores1, 1)
    _71 = torch.view(max_scores, [batch_size, 1])
    _72 = torch.expand(_71, [batch_size, nbest])
    minus_scores = torch.sub(scores1, _72)
    path_score = _0(minus_scores, 1, 3, None, )
    return (path_score, decode_idx1)
