def dropout(input: Tensor,
    p: float=0.5,
    training: bool=True,
    inplace: bool=False) -> Tensor:
  _0 = "dropout probability has to be between 0 and 1, but got {}"
  if torch.lt(p, 0.):
    _1 = True
  else:
    _1 = torch.gt(p, 1.)
  if _1:
    ops.prim.RaiseException(torch.format(_0, p))
  else:
    pass
  if inplace:
    _2 = torch.dropout_(input, p, training)
  else:
    _2 = torch.dropout(input, p, training)
  return _2
def _max_pool1d(input: Tensor,
    kernel_size: List[int],
    stride: Optional[List[int]]=None,
    padding: List[int]=[0],
    dilation: List[int]=[1],
    ceil_mode: bool=False,
    return_indices: bool=False) -> Tensor:
  _3 = "Note that order of the arguments: ceil_mode and return_indices will changeto match the args list in nn.MaxPool1d in a future release."
  if torch.ne(ceil_mode, return_indices):
    torch.warn(_3)
  else:
    pass
  if torch.__is__(stride, None):
    stride0 = annotate(List[int], [])
  else:
    stride0 = unchecked_cast(List[int], stride)
  _4 = torch.max_pool1d(input, kernel_size, stride0, padding, dilation, ceil_mode)
  return _4
def embedding(input: Tensor,
    weight: Tensor,
    padding_idx: Optional[int]=None,
    max_norm: Optional[float]=None,
    norm_type: float=2.,
    scale_grad_by_freq: bool=False,
    sparse: bool=False) -> Tensor:
  _5 = "AssertionError: Padding_idx must be within num_embeddings"
  if torch.__isnot__(padding_idx, None):
    padding_idx1 = unchecked_cast(int, padding_idx)
    if torch.gt(padding_idx1, 0):
      _6 = torch.lt(padding_idx1, torch.size(weight, 0))
      if _6:
        pass
      else:
        ops.prim.RaiseException(_5)
      padding_idx2 = padding_idx1
    else:
      if torch.lt(padding_idx1, 0):
        _7 = torch.neg(torch.size(weight, 0))
        if torch.ge(padding_idx1, _7):
          pass
        else:
          ops.prim.RaiseException(_5)
        padding_idx4 = torch.add(torch.size(weight, 0), padding_idx1)
        padding_idx3 = padding_idx4
      else:
        padding_idx3 = padding_idx1
      padding_idx2 = padding_idx3
    padding_idx0 = padding_idx2
  else:
    padding_idx0 = -1
  if torch.__isnot__(max_norm, None):
    input0 = torch.contiguous(input)
  else:
    input0 = input
  _8 = torch.embedding(weight, input0, padding_idx0, scale_grad_by_freq, sparse)
  return _8
def softmax(input: Tensor,
    dim: Optional[int]=None,
    _stacklevel: int=3,
    dtype: Optional[int]=None) -> Tensor:
  _9 = __torch__.torch.nn.functional._get_softmax_dim
  if torch.__is__(dim, None):
    dim1 = _9("softmax", torch.dim(input), _stacklevel, )
    dim0 = dim1
  else:
    dim0 = unchecked_cast(int, dim)
  if torch.__is__(dtype, None):
    ret = torch.softmax(input, dim0)
  else:
    dtype0 = unchecked_cast(int, dtype)
    ret = torch.softmax(input, dim0, dtype0)
  return ret
def _get_softmax_dim(name: str,
    ndim: int,
    stacklevel: int) -> int:
  _10 = "Implicit dimension choice for {} has been deprecated. Change the call to include dim=X as an argument."
  torch.warn(torch.format(_10, name), stacklevel)
  if torch.eq(ndim, 0):
    _11 = True
  else:
    _11 = torch.eq(ndim, 1)
  if _11:
    _12 = True
  else:
    _12 = torch.eq(ndim, 3)
  if _12:
    ret = 0
  else:
    ret = 1
  return ret
